# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-DBM-Deep
Version:	2.0013
Release:	3.%{__distinit}%{__distvers}
Summary:	A pure perl multi-level hash/array DBM
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/DBM-Deep/
Source0:	http://search.cpan.org/CPAN/authors/id/R/RK/RKINYON/DBM-Deep-%{version}.tar.gz
Patch1:		DBM-Deep-2.0012-old-Test::More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl >= 3:5.8.4
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Module::Build) >= 0.42
# Module Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(DBI) >= 1.5
BuildRequires:	perl(Digest::MD5)
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Config)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::Deep)
BuildRequires:	perl(Test::Exception)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Warn)
BuildRequires:	perl(utf8)
BuildRequires:	perl(vars)
# Optional Tests
BuildRequires:	perl(DBD::SQLite) >= 1.25
BuildRequires:	perl(FileHandle::Fmode)
BuildRequires:	perl(Pod::Simple)
BuildRequires:	perl(Pod::Usage) >= 1.3
BuildRequires:	perl(Test::Pod) >= 1.14
BuildRequires:	perl(Test::Pod::Coverage) >= 1.04
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)
Requires:	perl(Data::Dumper)
Requires:	perl(Digest::MD5)

# Hash::Util::FieldHash is used if available
%if 0%{?fedora} > 8 || 0%{?rhel} > 5
BuildRequires:	perl(Hash::Util::FieldHash)
Requires:	perl(Hash::Util::FieldHash)
%endif

%description
A unique flat-file database module, written in pure perl. True multi-level
hash/array support (unlike MLDBM, which is faked), hybrid OO / tie()
interface, cross-platform FTPable files, and quite fast. Can handle
millions of keys and unlimited hash levels without significant slow-down.
Written from the ground-up in pure perl - this is NOT a wrapper around a
C-based DBM. Out-of-the-box compatibility with Unix, Mac OS X and Windows.

%prep
%setup -q -n DBM-Deep-%{version}

# Test suite uses done_testing, which is only available in Test::More ≥ 0.88
%if %{old_test_more}
%patch1
%endif

%build
perl Build.PL --installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0
%{_fixperms} %{buildroot}

%check
LONG_TESTS=1 TEST_SQLITE=1 ./Build test

%clean
rm -rf %{buildroot}

%files
%doc Changes README
%{perl_vendorlib}/DBM/
%{_mandir}/man3/DBM::Deep.3*
%{_mandir}/man3/DBM::Deep::ConfigData.3*
%{_mandir}/man3/DBM::Deep::Cookbook.3*
%{_mandir}/man3/DBM::Deep::Engine.3*
%{_mandir}/man3/DBM::Deep::Engine::File.3*
%{_mandir}/man3/DBM::Deep::Internals.3*
%{_mandir}/man3/DBM::Deep::Iterator.3*
%{_mandir}/man3/DBM::Deep::Iterator::File::BucketList.3*
%{_mandir}/man3/DBM::Deep::Iterator::File::Index.3*
%{_mandir}/man3/DBM::Deep::Null.3*
%{_mandir}/man3/DBM::Deep::Storage.3*
%{_mandir}/man3/DBM::Deep::Storage::File.3*

%changelog
* Tue Aug 16 2016 Paul Howarth <paul@city-fan.org> - 2.0013-3
- BR: perl-generators where available
- Fix build dependencies when perl is not in the minimal buildroot

* Sat Jan  2 2016 Paul Howarth <paul@city-fan.org> - 2.0013-1
- Update to 2.0013
  - Documentation updates (GH#14, GH#15, GH#16)

* Wed Jun 17 2015 Paul Howarth <paul@city-fan.org> - 2.0012-1
- Update to 2.0012
  - Improved transaction validation and warnings (GH#12)
- Classify buildreqs by usage
- Use Hash::Util::FieldHash if we have perl ≥ 5.10
- Update patch for building with Test::More < 0.88

* Mon Sep 15 2014 Paul Howarth <paul@city-fan.org> - 2.0011-4
- Perl 5.20 rebuild

* Mon Jan 13 2014 Paul Howarth <paul@city-fan.org> - 2.0011-1
- Update to 2.0011
  - Pod fixes

* Tue Nov 12 2013 Paul Howarth <paul@city-fan.org> - 2.0010-1
- Update to 2.0010
  - Can push undefined values onto arrays
- Drop upstreamed POD patch

* Wed Jul 24 2013 Paul Howarth <paul@city-fan.org> - 2.0009-2
- Perl 5.18 rebuild

* Mon Jul  1 2013 Paul Howarth <paul@city-fan.org> - 2.0009-1
- Update to 2.0009
  - Fix for pushing non-true values in DBM::Deep::Array (CPAN RT#85414)
- This release by RKINYON -> update source URL
- Add patch to fix broken POD (CPAN RT#85252)
- Update patch for building with Test::More < 0.88

* Sun Jun 17 2012 Paul Howarth <paul@city-fan.org> - 2.0008-1
- Update to 2.0008 (#832921)
  - Arrays and hashes retrieved from a database no longer create circular
    references (CPAN RT#77746)
- Drop %%defattr, redundant since rpm 4.4
- Update patch for old Test::More versions

* Mon May 28 2012 Paul Howarth <paul@city-fan.org> - 2.0007-1
- Update to 2.0007
  - Include one-line descriptions of each POD page after the name
    (CPAN RT#76378)
  - t/98_pod.t: skip tests if Pod::Simple 3.21 is installed (CPAN RT#77419)
- BR: perl(Pod::Simple)
- Drop manpage for DBM::Deep::Sector::File; Pod commented out upstream

* Mon Apr  2 2012 Paul Howarth <paul@city-fan.org> - 2.0006-1
- Update to 2.0006
  - Try harder to get t/27_filehandle.t to work under TB2; the extra
    'TAP version 13' line was causing a TAP parse error

* Mon Mar 26 2012 Paul Howarth <paul@city-fan.org> - 2.0005-1
- Update to 2.0005 (t/27_filehandle.t has been fixed again; it no longer
  violates Test::Builder's encapsulation)
- BR: perl ≥ 5.8.4, perl(base), perl(constant) and perl(Exporter)
- BR/R: perl(Carp) and perl(Data::Dumper)
- Don't need to remove empty directories from the buildroot
- Drop support for distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Don't need to run test suite with LC_ALL=C

* Sun Oct  9 2011 Paul Howarth <paul@city-fan.org> - 2.0004-3
- BR/R: perl(Digest::MD5)

* Thu Jun 23 2011 Paul Howarth <paul@city-fan.org> - 2.0004-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Mon Sep 13 2010 Paul Howarth <paul@city-fan.org> - 2.0004-1
- Update to 2.0004 (t/27_filehandle.t has been fixed to work with Test::More 2)

* Sun Sep 12 2010 Paul Howarth <paul@city-fan.org> - 2.0003-1
- Update to 2.0003 (t/43_transaction_maximum.t has been fixed; it was broken in
  the previous release for systems that will only open so many files)

* Mon Sep  6 2010 Paul Howarth <paul@city-fan.org> - 2.0002-1
- Update to 2.0002
  - Error messages from DBM::Deep now use the caller’s file name; they used
    incorrectly to use the name of the program ($0)
  - begin_work now checks correctly to see whether the new transaction exceeds
    the number the file was created to support; sometimes it would allow a few
    more transactions, and then proceed to corrupt the database (RT#60903)
  - The description of the file header in DBM::Deep::Internals has been
    brought up to date
- Update patch for old Test::More versions

* Mon Aug 23 2010 Paul Howarth <paul@city-fan.org> - 2.0001-1
- Update to 2.0001 (simply reading a hash or array element no longer causes
  autovivification, though dereferencing it does still; this makes DBM::Deep
  comply with Perl’s behaviour - CPAN RT#60391)
- Update patch for old Test::More versions

* Mon Jul 19 2010 Paul Howarth <paul@city-fan.org> - 2.0000-1
- Update to 2.0000
  - THIS VERSION IS NOT FULLY COMPATIBLE WITH 1.002x
  - THIS VERSION CHANGES THE FILE FORMAT
  - Databases from DBM::Deep 1.0003 and higher can still be opened
  - Newly-created databases automatically use the version 2.x format
  - Version 1.x cannot open version 2.x format databases
  - The optimize method upgrades it as it creates a new database
  - There is a new db_version method
  - The File back end now supports Unicode for new databases
  - New external_refs mode
  - Numeric comparison of DBM::Deep objects now works
  - Deletions now work properly in the DBI back end
  - A memory leak caused by misuse of field hashes has been fixed
  - perl 5.8.4 is now required
  - Fixed compilation and overloading under perl 5.8.x
- Updated patch for old Test::More versions

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 1.0025-2
- Rebuild for perl 5.12.1 in Rawhide

* Mon Jun  7 2010 Paul Howarth <paul@city-fan.org> - 1.0025-1
- Update to 1.0025 (fixed t/39_singletons.t to work on Windows)

* Tue Jun  1 2010 Paul Howarth <paul@city-fan.org> - 1.0024-1
- Update to 1.0024
  - Stale references now compare equal to undef, "" and 0
  - Warn and assign undef if you assign a stale reference to a database location
  - Improve diagnostics when using a stale reference as a hash or array ref
  - Fix compatibility with perl 5.12.0
  - Singleton support has been re-enabled in the File back end
  - Fix t/43_transaction_maximum.t to detect maximum number of open files
- Update old-Test::More patch

* Wed May 19 2010 Paul Howarth <paul@city-fan.org> - 1.0021-2
- Fix dist tag for RHEL-6 Beta

* Mon Apr 19 2010 Paul Howarth <paul@city-fan.org> - 1.0021-1
- Update to 1.0021
  - Correct spelling mistakes in the documentation (CPAN RT#56520)
  - MANIFEST now lists the test libs so they get included (CPAN RT#56512)
  - It no longer crashes in perl 5.6.2
- Drop upstreamed test suite and POD spelling patches
- This release by SPROUT -> update source URL

* Wed Apr 14 2010 Paul Howarth <paul@city-fan.org> - 1.0020-2
- Replace DBM::Deep::Engine::Test patch with required files from upstream git
- Add patch to fix some POD spelling errors (CPAN RT#56520)

* Sat Apr 10 2010 Paul Howarth <paul@city-fan.org> - 1.0020-1
- Update to 1.0020
  - Fixed t/43_transaction_maximum.t for systems unable to fork > 255 children
  - Improved code coverage
  - Added t/96_virtual_functions.t which helps document plugins
- Patch around missing DBM::Deep::Engine::Test (CPAN RT#56512)
- Add lots of extra manpages
- Add buildreqs perl(DBI) and perl(DBD::SQLite), enable SQLite tests
- Add patch to support builds with Test::More < 0.88

* Fri Feb  5 2010 Paul Howarth <paul@city-fan.org> - 1.0014-2
- Add buildreq perl(FileHandle::Fmode) for additional test coverage
- Enable long tests (nowhere near as long as the Crypt::DH tests!)

* Mon Feb  1 2010 Paul Howarth <paul@city-fan.org> - 1.0014-1
- Import from Fedora
- Update to 1.0014

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.983-6
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.983-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.983-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Mar 04 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.983-3
- Rebuild for new perl

* Fri Sep 08 2006 Andreas Thienemann <andreas@bawue.net> - 0.983-2
- FE6 Rebuild

* Thu Apr 27 2006 Andreas Thienemann <andreas@bawue.net> - 0.983-1
- Specfile autogenerated by cpanspec 1.64
- Cleaned up for FE
